
#include <cstdio>
#include <queue>
#include <vector>

class pond {
public:
	int index;
	double capacity;
	int flows;

	pond() {}

	pond(int index, int capacity) {
		this->index = index;
		this->capacity = capacity;
		this->flows = 1;
	}

	bool operator()(pond *lhs, pond *rhs) {
		return (lhs->capacity / lhs->flows) >= (rhs->capacity / rhs->flows);
	}
};

int main() {

	int i;
	int N,F;
	int temp_cap;

	while (scanf("%d %d",&N, &F)) {
		std::priority_queue<pond*,std::vector<pond*>, pond> ponds;
		pond **by_index = new pond*[N];
		for (i = 0; i < N; i++) {
			scanf("%d",&temp_cap);
			pond *p = new pond(i, temp_cap);
			ponds.push(p);
			by_index[i] = p;
		}

		while (ponds.size() != 0) {
			pond *top = ponds.top();

			double time = top->capacity / (top->flows * F);
			for (i = 0; i < N; i++) {
				by_index[i]->capacity -= by_index[i]->flows * F * time;
			}
			if (ponds.size() > 1) {
				(by_index[top->index + 1]->flows)++;
			}
			ponds.pop();
			printf("size: %lfn",ponds.size());
		}
	}

	return 0;
}
