
#include <cstdio>
#include <map>

class DLL {
public:
	int dtype;
	DLL *next;
	DLL *prev;

	DLL() { this->next = NULL; this->prev = NULL; }
};

int main() {

	int n;

	while (scanf("%d",&n) > 0) {

		int array[n];
		std::map<int,int> dt;

		for (int i = 0; i < n; i++) {
			scanf("%d",&array[i]);
			if (dt.find(array[i]) != dt.end()) {
				dt[array[i]]++;
			} else {
				dt[array[i]] = 1;
			}
		}

		DLL *start = NULL;
		DLL *end = NULL;

		int listLength = 0;

		for (int i = 0; i < n; i++) {
			if (dt[array[i]] > 1) {
				listLength++;
				if (start == NULL) {
					start = end = new DLL();
					start->dtype = array[i];
				} else {
					end->next = new DLL();
					end->next->dtype = array[i];
					end->next->prev = end;
					end = end->next;
				}
			}
		}

		int filtered[listLength];
		int j = 0;
		for (DLL *current = start; current != NULL; current = current->next) {
			filtered[j] = current->dtype;
			j++;
		}

		std::map<int,int> lmap;

		int depth = 0;

		int ldepth[listLength];
		int rdepth[listLength];

		for (int i = 0; i < listLength; i++) {
			int elm = filtered[i];
			if (lmap.find(elm) == lmap.end()) {
				lmap[elm] = 1;
				depth++;
			} else {
				lmap[elm]++;
				depth--;
			}
			ldepth[i] = depth;
		}

		depth = 0;

		std::map<int,int> rmap;		

		for (int i = listLength - 1; i >= 0; i--) {
			int elm = filtered[i];
			if (rmap.find(elm) == rmap.end()) {
				rmap[elm] = 1;
				depth++;
			} else {
				if (rmap[elm] % 2 == 1) {
					depth++;
				}
				rmap[elm]++;
				depth--;
			}
			rdepth[i] = depth;
		}

		depth = 0;

		for (int i = listLength - 1; i >= 0; i--) {
			if (ldepth[i] == rdepth[i]) {
				if (ldepth[i] > depth) {
					depth = ldepth[i];
				}
			}
		}

		printf("%d\n",depth);

		
	}

	return 0;
}
